> For the complete documentation index, see [llms.txt](https://docs.console.zenlayer.com/api-reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.console.zenlayer.com/api-reference/cn/zlb/load-balancer-listener/describelisteners.md).

# DescribeListeners

## 1. 接口描述

本接口(DescribeListeners)用于可根据负载均衡器ID、监听器的协议作为过滤条件获取监听器列表。如果不指定任何过滤条件，则返回指定负载均衡实例下的所有监听器。

## 2. 请求参数

以下请求参数列表仅列出了接口中需要的请求参数

| 参数名称           | 必选 | 类型                                                                          | 描述                                                                                                                                          |
| -------------- | -- | --------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------- |
| loadBalancerId | 是  | String                                                                      | <p>负载均衡实例的ID。</p><p>可通过调用 <a href="/api-reference/cn/zlb/load-balancer-instance/describeloadbalancers.md">DescribeLoadBalancers</a> 获取。</p> |
| listenerIds    | 否  | Array of String                                                             | 要查询的负载均衡监听器ID列表。                                                                                                                            |
| protocol       | 否  | [ListenerProtocol](/api-reference/cn/zlb/datastructure.md#listenerprotocol) | 要查询的监听器协议类型。                                                                                                                                |

## 3. 响应结果

| 参数名称      | 类型                                                                   | 描述                                                       |
| --------- | -------------------------------------------------------------------- | -------------------------------------------------------- |
| requestId | String                                                               | <p>唯一请求 ID。</p><p>每次请求都会返回。定位问题时需要提供该次请求的 requestId。</p> |
| listeners | Array of [Listener](/api-reference/cn/zlb/datastructure.md#listener) | 监听器列表。                                                   |

## 4. 代码示例

{% tabs %}
{% tab title="示例" %}
**1. 查询指定负载均衡实例下所有的监听器。**

```json
POST /api/v2/zlb HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: DescribeListeners
<Common Request Params>

Request：
{
  "loadBalancerId": "<loadBalancerId>"
}

Response：
{
  "requestId": "TFF2866DD-E3CF-47E4-8B52-D141992D6BB6",
  "response": {
    "listeners": [
      {
        "scheduler": "mh",
        "listenerId": "<loadBalancerId>",
        "protocol": "TCP",
        "port": "40",
        "createTime": "2025-01-01T01:01:01Z",
        "listenerName": "sample-name",
        "ipStackType": "IPv4",
        "kind": "DR",
        "healthCheck": {
          "checkType": null,
          "checkHttpGetUrl": "",
          "checkDelayTry": null,
          "checkConnTimeout": null,
          "checkHttpStatusCode": null,
          "checkPort": null,
          "checkRetry": null,
          "enabled": false,
          "checkDelayLoop": null,
          "failOpen": false
        },
        "persistent": 60,
        "idleTimeout": 300,
        "algoOpts": "StatelessForwarding"
      }
    ],
    "requestId": "TFF2866DD-E3CF-47E4-8B52-D141992D6BB6"
  }
}
```

**2. 指定监听器和监听协议过滤查询监听器。**

```json
POST /api/v2/zlb HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: DescribeListeners
<Common Request Params>

Request：
{
  "loadBalancerId": "<loadBalancerId>",
  "protocol": "TCP"
}

Response：
{
  "requestId": "TFF2866DD-E3CF-47E4-8B52-D141992D6BB6",
  "response": {
    "listeners": [
      {
        "scheduler": "mh",
        "listenerId": "<loadBalancerId>",
        "protocol": "TCP",
        "port": "40",
        "createTime": "2025-01-01T01:01:01Z",
        "listenerName": "sample-name",
        "ipStackType": "IPv4",
        "kind": "DR",
        "healthCheck": {
          "checkType": null,
          "checkHttpGetUrl": "",
          "checkDelayTry": null,
          "checkConnTimeout": null,
          "checkHttpStatusCode": null,
          "checkPort": null,
          "checkRetry": null,
          "enabled": false,
          "checkDelayLoop": null,
          "failOpen": false
        },
        "persistent": 60,
        "idleTimeout": 300,
        "algoOpts": "StatelessForwarding"
      }
    ],
    "requestId": "TFF2866DD-E3CF-47E4-8B52-D141992D6BB6"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. 开发者工具

Zenlayer Cloud API 2.0 提供了配套的[开发工具集（SDK）](/api-reference/cn/api-introduction/toolkit.md)，未来会陆续支持更多开发语言，方便快速接入和使用Zenlayer的产品和服务。

## 6. 错误码

下面包含业务逻辑中遇到的错误码，其他错误码见[公共错误码](/api-reference/cn/api-introduction/instruction/commonerrorcode.md)

| HTTP状态码 | 错误码 | 说明 |
| ------- | --- | -- |
